diff -Nur linux-2.6.9-intc1/drivers/misc/wm97xx.h linux-2.6.9-intc1-mih1/drivers/misc/wm97xx.h
--- linux-2.6.9-intc1/drivers/misc/wm97xx.h	1969-12-31 19:00:00.000000000 -0500
+++ linux-2.6.9-intc1-mih1/drivers/misc/wm97xx.h	2005-04-22 02:35:42.000000000 -0400
@@ -0,0 +1,308 @@
+/*
+ * Register bits for Wolfson WM97xx series of codecs
+ */
+ 
+#ifndef _WM97XX_H_
+#define _WM97XX_H_
+
+#include <sound/driver.h>
+#include <sound/core.h>
+#include <sound/pcm.h>
+#include <sound/ac97_codec.h>
+#include <sound/initval.h>
+#include <linux/input.h>		/* Input device layer */
+
+/*
+ * WM97xx AC97 Touchscreen registers
+ */
+#define AC97_WM97XX_DIGITISER1	0x76
+#define AC97_WM97XX_DIGITISER2	0x78
+#define AC97_WM97XX_DIGITISER_RD 0x7a
+#define AC97_WM9713_DIG1		0x74
+#define AC97_WM9713_DIG2		AC97_WM97XX_DIGITISER1
+#define AC97_WM9713_DIG3		AC97_WM97XX_DIGITISER2
+
+/*
+ * WM97xx register bits
+ */
+#define WM97XX_POLL		0x8000		/* initiate a polling measurement */
+#define WM97XX_ADCSEL_X		0x1000		/* x coord measurement */
+#define WM97XX_ADCSEL_Y		0x2000		/* y coord measurement */
+#define WM97XX_ADCSEL_PRES	0x3000		/* pressure measurement */
+#define WM97XX_ADCSEL_MASK	0x7000
+#define WM97XX_COO		0x0800		/* enable coordinate mode */
+#define WM97XX_CTC		0x0400		/* enable continuous mode */
+#define WM97XX_CM_RATE_93	0x0000		/* 93.75Hz continuous rate */
+#define WM97XX_CM_RATE_187	0x0100		/* 187.5Hz continuous rate */
+#define WM97XX_CM_RATE_375	0x0200		/* 375Hz continuous rate */
+#define WM97XX_CM_RATE_750	0x0300		/* 750Hz continuous rate */
+#define WM97XX_CM_RATE_8K	0x00f0		/* 8kHz continuous rate */
+#define WM97XX_CM_RATE_12K	0x01f0		/* 12kHz continuous rate */
+#define WM97XX_CM_RATE_24K	0x02f0		/* 24kHz continuous rate */
+#define WM97XX_CM_RATE_48K	0x03f0		/* 48kHz continuous rate */
+#define WM97XX_CM_RATE_MASK	0x03f0
+#define WM97XX_RATE(i)		(((i & 3) << 8) | ((i & 4) ? 0xf0 : 0))
+#define WM97XX_DELAY(i)		((i << 4) & 0x00f0)	/* sample delay times */
+#define WM97XX_DELAY_MASK	0x00f0
+#define WM97XX_SLEN		0x0008		/* slot read back enable */
+#define WM97XX_SLT(i)		((i - 5) & 0x7)	/* touchpanel slot selection (5-11) */
+#define WM97XX_SLT_MASK		0x0007
+#define WM97XX_PRP_DETW		0x4000		/* pen detect on, digitiser off, wake up */
+#define WM97XX_PRP_DET		0x8000		/* pen detect on, digitiser off, no wake up */
+#define WM97XX_PRP_DET_DIG	0xc000		/* pen detect on, digitiser on */
+#define WM97XX_RPR		0x2000		/* wake up on pen down */
+#define WM97XX_PEN_DOWN		0x8000		/* pen is down */
+#define WM97XX_ADCSRC_MASK	0x7000		/* ADC source mask */
+
+#define WM97XX_AUX_ID1      0x8001
+#define WM97XX_AUX_ID2      0x8002
+#define WM97XX_AUX_ID3      0x8003
+#define WM97XX_AUX_ID4      0x8004
+
+
+/* WM9712 Bits */
+#define WM9712_45W		0x1000		/* set for 5-wire touchscreen */
+#define WM9712_PDEN		0x0800		/* measure only when pen down */
+#define WM9712_WAIT		0x0200		/* wait until adc is read before next sample */
+#define WM9712_PIL		0x0100		/* current used for pressure measurement. set 400uA else 200uA */ 
+#define WM9712_MASK_HI		0x0040		/* hi on mask pin (47) stops conversions */
+#define WM9712_MASK_EDGE	0x0080		/* rising/falling edge on pin delays sample */
+#define	WM9712_MASK_SYNC	0x00c0		/* rising/falling edge on mask initiates sample */
+#define WM9712_RPU(i)		(i&0x3f)	/* internal pull up on pen detect (64k / rpu) */
+#define WM9712_PD(i)		(0x1 << i)  /* power management */ 
+
+/* WM9712 Registers */
+#define AC97_WM9712_POWER	0x24
+#define AC97_WM9712_REV		0x58
+
+/* WM9705 Bits */
+#define WM9705_PDEN		0x1000		/* measure only when pen is down */
+#define WM9705_PINV		0x0800		/* inverts sense of pen down output */
+#define WM9705_BSEN		0x0400		/* BUSY flag enable, pin47 is 1 when busy */
+#define WM9705_BINV		0x0200		/* invert BUSY (pin47) output */
+#define WM9705_WAIT		0x0100		/* wait until adc is read before next sample */
+#define WM9705_PIL		0x0080		/* current used for pressure measurement. set 400uA else 200uA */ 
+#define WM9705_PHIZ		0x0040		/* set PHONE and PCBEEP inputs to high impedance */
+#define WM9705_MASK_HI		0x0010		/* hi on mask stops conversions */
+#define WM9705_MASK_EDGE	0x0020		/* rising/falling edge on pin delays sample */
+#define	WM9705_MASK_SYNC	0x0030		/* rising/falling edge on mask initiates sample */
+#define WM9705_PDD(i)		(i & 0x000f)	/* pen detect comparator threshold */
+
+
+/* WM9713 Bits */
+#define WM9713_PDPOL		0x0400		/* Pen down polarity */
+#define WM9713_POLL			0x0200		/* initiate a polling measurement */
+#define WM9713_CTC			0x0100		/* enable continuous mode */
+#define WM9713_ADCSEL_X		0x0002		/* X measurement */
+#define WM9713_ADCSEL_Y		0x0004		/* Y measurement */
+#define WM9713_ADCSEL_PRES	0x0008		/* Pressure measurement */
+#define WM9713_COO			0x0001		/* enable coordinate mode */
+#define WM9713_PDEN			0x0800		/* measure only when pen down */
+#define WM9713_ADCSEL_MASK	0x00fe		/* ADC selection mask */
+
+/* AUX ADC ID's */
+#define TS_COMP1		0x0
+#define TS_COMP2		0x1
+#define TS_BMON			0x2
+#define TS_WIPER		0x3
+
+/* ID numbers */
+#define WM97XX_ID1		0x574d
+#define WM9712_ID2		0x4c12
+#define WM9705_ID2		0x4c05
+#define WM9713_ID2		0x4c13
+
+/* Codec GPIO's */
+#define WM97XX_MAX_GPIO	16
+#define WM97XX_GPIO_1	(1 << 1)
+#define WM97XX_GPIO_2	(1 << 2)
+#define WM97XX_GPIO_3	(1 << 3)
+#define WM97XX_GPIO_4	(1 << 4)
+#define WM97XX_GPIO_5	(1 << 5)
+#define WM97XX_GPIO_6	(1 << 6)
+#define WM97XX_GPIO_7	(1 << 7)
+#define WM97XX_GPIO_8	(1 << 8)
+#define WM97XX_GPIO_9	(1 << 9)
+#define WM97XX_GPIO_10	(1 << 10)
+#define WM97XX_GPIO_11	(1 << 11)
+#define WM97XX_GPIO_12	(1 << 12)
+#define WM97XX_GPIO_13	(1 << 13)
+#define WM97XX_GPIO_14	(1 << 14)
+#define WM97XX_GPIO_15	(1 << 15)
+
+
+#define AC97_LINK_FRAME		21		/* time in uS for AC97 link frame */
+
+
+/*---------------- Return codes from sample reading functions ---------------*/
+
+/* More data is available; call the sample gathering function again */
+#define RC_AGAIN		0x00000001
+/* The returned sample is valid */
+#define RC_VALID		0x00000002
+/* The pen is up (the first RC_VALID without RC_PENUP means pen is down) */
+#define RC_PENUP		0x00000004
+/* The pen is down (RC_VALID implies RC_PENDOWN, but sometimes it is helpful
+   to tell the handler that the pen is down but we don't know yet his coords,
+   so the handler should not sleep or wait for pendown irq) */
+#define RC_PENDOWN		0x00000008
+
+/* The wm97xx driver provides a private API for writing platform-specific
+ * drivers. 
+ */
+
+/* The structure used to return arch specific sampled data into */
+struct wm97xx_data {
+	int x;
+	int y;
+	int p;
+};
+
+/* Codec GPIO status
+ */
+typedef enum {
+	WM97XX_GPIO_HIGH,
+	WM97XX_GPIO_LOW
+} wm97xx_gpio_status_t;
+
+/* Codec GPIO direction
+ */
+typedef enum {
+	WM97XX_GPIO_IN,
+	WM97XX_GPIO_OUT
+} wm97xx_gpio_dir_t;
+
+/* Codec GPIO polarity
+ */
+typedef enum {
+	WM97XX_GPIO_POL_HIGH,
+	WM97XX_GPIO_POL_LOW
+} wm97xx_gpio_pol_t;
+
+/* Codec GPIO sticky
+ */
+typedef enum {
+	WM97XX_GPIO_STICKY,
+	WM97XX_GPIO_NOTSTICKY
+} wm97xx_gpio_sticky_t;
+
+/* Codec GPIO wake
+ */
+typedef enum {
+	WM97XX_GPIO_WAKE,
+	WM97XX_GPIO_NOWAKE
+} wm97xx_gpio_wake_t;
+
+/*
+ * codec event callback.
+ */
+typedef int (*codec_event_t)(int status);
+
+/*
+ * arch apecific continuous mode read callback
+ */
+typedef int (*codec_read_t)(struct input_dev* idev, int pen_down_time, int pressure);
+
+struct wm97xx;
+struct wm97xx_codec;
+struct wm97xx_auxconv_data;
+
+/*
+ * Codec interface
+ */
+struct wm97xx_codec{
+	int (*poll_sample)(struct wm97xx*, int adcsel, int *sample); 	/* read 1 sample */
+	int (*poll_coord)(struct wm97xx*, struct wm97xx_data*);			/* read X,Y,[P} in coord */
+	int (*poll_touch)(struct wm97xx*, struct wm97xx_data*);			/* read X,Y,[P] in poll */
+	void (*init_phy)(struct wm97xx*);
+	void (*codec_suspend)(struct wm97xx*);
+	void (*codec_resume)(struct wm97xx*);
+	void (*digitiser_save)(struct wm97xx*);
+	void (*digitiser_restore)(struct wm97xx*);
+	void (*aux_prepare)(struct wm97xx*);
+	void (*set_continuous_mode)(struct wm97xx*, int enable, int slot, int rate);
+	void (*digitiser_start)(struct wm97xx*);
+	void (*digitiser_stop)(struct wm97xx*);
+};
+
+struct wm97xx {
+	struct mcp	*mcp;	/* this needs to be first */
+	u16 dig1, dig2, dig3, id;			/* Cached codec registers */
+	struct wm97xx_codec* wm97xx_codec;
+	struct input_dev wm97xx_input;
+	struct device* dev;
+	int pressure;
+	int mode;
+	struct completion ts_init;
+	struct completion ts_exit;
+	struct task_struct *ts_task;
+	codec_read_t cont_read_sample;		/* continuous mode reader */
+	unsigned int pen_irq;				/* Pen IRQ number in use */
+	unsigned int pen_irq_count;
+	unsigned int codec_irq;				/* Codec IRQ number in use */
+	unsigned int codec_irq_count;
+	wait_queue_head_t pen_irq_wait;		/* Pen IRQ wait queue */
+	int codec_irq_ref_count;			/* Number of gpio irq users */
+	struct workqueue_struct *pen_irq_workq;
+	struct work_struct pen_event_work;
+	struct workqueue_struct *codec_event_workq;
+	struct work_struct codec_event_work;
+	codec_event_t codec_event[WM97XX_MAX_GPIO]; /* codec event handlers */
+	struct class_device	cdev;
+	spinlock_t lock;					/* Hardware lock */
+	struct semaphore sem;
+	unsigned int pen_is_down;			/* Pen down time */
+	unsigned int ts_use_count;
+	unsigned aux_waiting:1;			/* aux measurement waiting */
+	unsigned ac97_link:1;			/* interrupt over AC link */
+	unsigned pen_probably_down:1;	/* used in polling and coordinate modes */
+	unsigned pen_is_up:1;			/* pen is up */
+#if defined(CONFIG_PM)
+	unsigned phone_pga:5;			/* PGA settings for PM */
+	unsigned line_pga:16;
+	unsigned mic_pga:16;
+#endif
+};
+
+#define classdev_to_wm97xx(cd)	container_of(cd, struct wm97xx, cdev)
+
+int wm97xx_register_interface(struct class_interface *intf);
+void wm97xx_unregister_interface(struct class_interface *intf);
+
+/* Enable or disable continuous mode. The driver itself doesn't
+ * support continuous mode since it is highly architecture-specific.
+ */
+extern void wm97xx_set_continuous_mode (struct wm97xx *wm, codec_read_t read, int enable, int slot, int rate);
+
+/* Codec IRQ access
+ * The codec can generate IRQ's (over AC97 link or IRQ pin) for 
+ * numerous external or internal events. This is used to 
+ * enable and disable codec IRQ's
+ */
+extern int wm97xx_set_codec_irq(struct wm97xx *wm, int irq, int link);
+extern int wm97xx_clear_codec_irq(struct wm97xx *wm); 
+ 
+/* Register interest in external/internal codec events */
+extern int wm97xx_request_codec_event(struct wm97xx *wm, int gpio, codec_event_t work);
+extern void wm97xx_free_codec_event(struct wm97xx *wm, int gpio);
+ 
+/* Codec PEN IRQ access
+ * The codec can additionally generate an IRQ (using a dedicated pin) 
+ * for Pen down events. This is used to enable and disable codec 
+ * Pen down IRQ's
+ */
+extern int wm97xx_set_pen_irq(struct wm97xx *wm, int irq);
+extern void wm97xx_clear_pen_irq(struct wm97xx *wm); 
+
+/* Codec GPIO access (not supported on WM9705)
+ * This can be used to set/get codec GPIO and Virtual GPIO status.
+ */
+extern wm97xx_gpio_status_t wm97xx_get_codec_gpio (struct wm97xx *wm, u32 gpio);
+extern void wm97xx_set_codec_gpio (struct wm97xx *wm, u32 gpio, wm97xx_gpio_status_t status);
+extern void wm97xx_config_codec_gpio (struct wm97xx *wm, u32 gpio, wm97xx_gpio_dir_t dir, wm97xx_gpio_pol_t pol,
+							wm97xx_gpio_sticky_t sticky, wm97xx_gpio_wake_t wake);
+							
+void wm97xx_ts_input_close(struct input_dev *idev);
+int wm97xx_ts_input_open(struct input_dev *idev);
+
+#endif
diff -Nur linux-2.6.9-intc1/drivers/misc/xircom_gem.c linux-2.6.9-intc1-mih1/drivers/misc/xircom_gem.c
--- linux-2.6.9-intc1/drivers/misc/xircom_gem.c	1969-12-31 19:00:00.000000000 -0500
+++ linux-2.6.9-intc1-mih1/drivers/misc/xircom_gem.c	2005-03-17 18:46:22.000000000 -0500
@@ -0,0 +1,157 @@
+/*
+ * xircom_gem.c: adds entries to /proc fs to control Xircom/Intel modem
+ * - write 1 to assert, delay 250ms, and deassert pin
+ * - write 2 to assert pin, write 0 to deassert pin
+ *
+  *  Copyright (c) 2005 Matthias Ihmig <m.ihmig@gmx.net>
+ *
+ * This program is free software; you can redistribute
+ * it and/or modify it under the terms of the GNU General
+ * Public License as published by the Free Software
+ * Foundation; either version 2 of the License, or (at your
+ * option) any later version.
+ *
+ * This program is distributed in the hope that it will be
+ * useful, but WITHOUT ANY WARRANTY; without even the implied
+ * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+ * PURPOSE.  See the GNU General Public License for more
+ * details.
+ */
+
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/proc_fs.h>
+#include <linux/delay.h>
+#include <asm/uaccess.h>
+
+#include <asm/hardware.h>
+#include <asm/arch/pxa-regs.h>
+#include <asm/arch/glencoe.h>
+
+#define MODULE_VERS "1.0"
+#define MODULE_NAME "xircom_gem"
+
+static struct proc_dir_entry *gem_dir, *asleep, *power_down, *wake_up, *reset;
+
+static int proc_read_gem(char *page, char **start, off_t off, int count,
+			     int *eof, void *data)
+{
+	return sprintf(page, "%s\n", (GPIO_lev( (int)data) ? "0" : "1")); // active low signal -> invert
+}
+
+static int proc_write_gem(struct file *file, const char *buffer,
+			     unsigned long count, void *data)
+{
+	int len=0;
+	char value='0';
+
+	if(count >= 1)
+		len = 1;
+	else
+		return -EFAULT;
+
+	if(copy_from_user(&value, buffer, len))
+		return -EFAULT;
+
+	if (value == '1' || value == '2')
+		GPIO_clr( (int)data );		// assert pin (active low)
+	if (value == '1')
+		mdelay(250);			// wait 250ms when value=1
+	if (value == '1' || value == '0')
+		GPIO_set( (int)data );		// deassert pin
+	return len;
+}
+
+static int __init init_xircom_gem(void)
+{
+	int rv = 0;
+	
+	// Initialize GPIO registers
+	pxa_gpio_mode(GLN_GPIO_nGEM_WAKE  | GPIO_OUT);
+	pxa_gpio_mode(GLN_GPIO_nGEM_SLEEP | GPIO_IN);
+	pxa_gpio_mode(GLN_GPIO_nGEM_RST   | GPIO_OUT);
+	pxa_gpio_mode(GLN_GPIO_nGEM_PWR_DWN|GPIO_OUT);
+	
+	/* create directory */
+	gem_dir = proc_mkdir("driver/" MODULE_NAME, NULL);
+	if(gem_dir == NULL) {
+		rv = -ENOMEM; goto out;
+	}
+	gem_dir->owner = THIS_MODULE;
+	
+	asleep = create_proc_read_entry("asleep", 0444, gem_dir, proc_read_gem, (void*)GLN_GPIO_nGEM_SLEEP);
+	if(asleep == NULL) {
+		rv  = -ENOMEM; goto no_asleep;
+	}
+	asleep->owner = THIS_MODULE;
+
+	
+	power_down = create_proc_entry("power_down", 0644, gem_dir);
+	if(power_down == NULL) {
+		rv = -ENOMEM;
+		goto no_power_down;
+	}
+	power_down->data = (void*)GLN_GPIO_nGEM_PWR_DWN;
+	power_down->read_proc = proc_read_gem;
+	power_down->write_proc = proc_write_gem;
+	power_down->owner = THIS_MODULE;
+
+	
+	wake_up = create_proc_entry("wake_up", 0644, gem_dir);
+	if(wake_up == NULL) {
+		rv = -ENOMEM;
+		goto no_wake_up;
+	}
+	wake_up->data = (void*)GLN_GPIO_nGEM_WAKE;
+	wake_up->read_proc = proc_read_gem;
+	wake_up->write_proc = proc_write_gem;
+	wake_up->owner = THIS_MODULE;
+		
+	
+	reset = create_proc_entry("reset", 0644, gem_dir);
+	if(reset == NULL) {
+		rv = -ENOMEM;
+		goto no_reset;
+	}
+	reset->data = (void*)GLN_GPIO_nGEM_RST;
+	reset->read_proc = proc_read_gem;
+	reset->write_proc = proc_write_gem;
+	reset->owner = THIS_MODULE;
+	
+	/* everything OK */
+	printk(KERN_INFO "%s %s proc interface initialised\n",
+	       MODULE_NAME, MODULE_VERS);
+	return 0;
+
+no_reset:
+	remove_proc_entry("wake_up", gem_dir);
+no_wake_up:
+	remove_proc_entry("power_down", gem_dir);
+no_power_down:
+	remove_proc_entry("asleep", gem_dir);
+no_asleep:			      
+	remove_proc_entry(MODULE_NAME, NULL);
+out:
+	return rv;
+}
+
+static void __exit cleanup_xircom_gem(void)
+{
+	remove_proc_entry("power_down", gem_dir);
+	remove_proc_entry("wake_up", gem_dir);
+	remove_proc_entry("reset", gem_dir);
+	remove_proc_entry("asleep", gem_dir);
+	remove_proc_entry(MODULE_NAME, NULL);
+
+	printk(KERN_INFO "%s %s interface removed\n",
+	       MODULE_NAME, MODULE_VERS);
+}
+
+module_init(init_xircom_gem);
+module_exit(cleanup_xircom_gem);
+
+MODULE_AUTHOR("Matthias Ihmig <m.ihmig@mytum.de>");
+MODULE_DESCRIPTION("Xircom/Intel GEM module /proc interface");
+MODULE_LICENSE("GPL");
+
diff -Nur linux-2.6.9-intc1/drivers/mmc/mmc_block.c linux-2.6.9-intc1-mih1/drivers/mmc/mmc_block.c
--- linux-2.6.9-intc1/drivers/mmc/mmc_block.c	2004-10-18 17:55:36.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/mmc/mmc_block.c	2005-02-26 18:32:06.000000000 -0500
@@ -180,7 +180,7 @@
 
 		brq.cmd.arg = req->sector << 9;
 		brq.cmd.flags = MMC_RSP_R1;
-		brq.data.req = req;
+//		brq.data.req = req;	// needed?
 		brq.data.timeout_ns = card->csd.tacc_ns * 10;
 		brq.data.timeout_clks = card->csd.tacc_clks * 10;
 		brq.data.blksz_bits = md->block_bits;
@@ -200,6 +200,9 @@
 		}
 		brq.mrq.stop = brq.data.blocks > 1 ? &brq.stop : NULL;
 
+		brq.data.sg = mq->sg;
+		brq.data.sg_len = blk_rq_map_sg(req->q, req, brq.data.sg);
+
 		mmc_wait_for_req(card->host, &brq.mrq);
 		if (brq.cmd.error) {
 			printk(KERN_ERR "%s: error %d sending read/write command\n",
@@ -330,6 +333,18 @@
 		md->disk->queue = md->queue.queue;
 		md->disk->driverfs_dev = &card->dev;
 
+		/*
+		 * As discussed on lkml, GENHD_FL_REMOVABLE should:
+		 *
+		 * - be set for removable media with permanent block devices
+		 * - be unset for removable block devices with permanent media
+		 *
+		 * Since MMC block devices clearly fall under the second
+		 * case, we do not set GENHD_FL_REMOVABLE.  Userspace
+		 * should use the block device creation/destruction hotplug
+		 * messages to tell when the card is present.
+		 */
+
 		sprintf(md->disk->disk_name, "mmcblk%d", devidx);
 		sprintf(md->disk->devfs_name, "mmc/blk%d", devidx);
 
diff -Nur linux-2.6.9-intc1/drivers/mmc/mmc.c linux-2.6.9-intc1-mih1/drivers/mmc/mmc.c
--- linux-2.6.9-intc1/drivers/mmc/mmc.c	2004-10-18 17:54:08.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/mmc/mmc.c	2005-05-01 01:52:39.000000000 -0400
@@ -1,11 +1,14 @@
 /*
- *  linux/drivers/mmc/mmc.c
+ *  linux/drivers/mmc/mmc.c (with parts backported from 2.6.11)
  *
  *  Copyright (C) 2003-2004 Russell King, All Rights Reserved.
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
  * published by the Free Software Foundation.
+ *
+ *  SD support (c) 2004 Ian Molton.
+ *
  */
 #include <linux/config.h>
 #include <linux/module.h>
@@ -216,8 +219,33 @@
 		cmd.flags = MMC_RSP_R1;
 
 		err = mmc_wait_for_cmd(host, &cmd, CMD_RETRIES);
+
+		if(err != MMC_ERR_NONE)
+			goto out;
+
+		/* Select 4 bit mode on SD cards note: a 4 bit mmc standard is
+		 * on the table... watch this space.
+		 */
+		if(host->flags & HOST_CAP_SD_4_BIT &&
+		   card->state & MMC_STATE_IS_SD) {
+			cmd.opcode = MMC_APP_CMD;
+			cmd.arg = card->rca << 16;
+			cmd.flags = MMC_RSP_R1;
+			err = mmc_wait_for_cmd(host, &cmd, CMD_RETRIES);
+			if(err != MMC_ERR_NONE) {
+				goto out;
+			}
+			cmd.opcode = SD_APP_SET_BUS_WIDTH;
+			cmd.arg = 2;
+			cmd.flags = MMC_RSP_R1 | MMC_FLAG_ACMD;
+			err = mmc_wait_for_cmd(host, &cmd, CMD_RETRIES);
+			if(err != MMC_ERR_NONE)
+				DBG("Error selecting 4 bit bus mode\n");
+		}
+		
 	}
 
+out:
 	return err;
 }
 
@@ -299,19 +327,20 @@
 	return ocr;
 }
 
-#define UNSTUFF_BITS(resp,start,size)					\
+	#define UNSTUFF_BITS(resp,start,size)					\
 	({								\
-		const u32 __mask = (1 << (size)) - 1;			\
+		const int __size = size;				\
+		const u32 __mask = (__size < 32 ? 1 << __size : 0) - 1;	\
 		const int __off = 3 - ((start) / 32);			\
 		const int __shft = (start) & 31;			\
 		u32 __res;						\
 									\
 		__res = resp[__off] >> __shft;				\
-		if ((size) + __shft >= 32)				\
-			__res |= resp[__off-1] << (32 - __shft);	\
+		if (__size + __shft > 32)				\
+			__res |= resp[__off-1] << ((32 - __shft) % 32);	\
 		__res & __mask;						\
 	})
-
+	
 /*
  * Given the decoded CSD structure, decode the raw CID to our CID structure.
  */
@@ -327,6 +356,38 @@
 	 */
 	switch (card->csd.mmca_vsn) {
 	case 0: /* MMC v1.? */
+		/*
+		 * Based on what I know, this is a SD card -Ian Molton
+		 * 
+		 * Unknown card (OEM card 'Traveller')
+		 * CID: 01504153 31323842 4134758d d0003400
+		 * CSD: 005d0132 135983d3 f6da4fff 16400000
+		 * Sandisk 32MB SD
+		 * CID: 03534453 44303332 318e01af 22002b00
+		 * CSD: 00260032 1f5981d2 ecb5cfff 92404000
+		 * Lexar 256MB SD (40x)
+		 * CID: 154d4353 4d492020 00120456 69003a00
+		 * CSD: 007f0032 1f5983cf f6dabf9f 96600000
+		 * Sandisk 128MB card:
+		 * CID: 03534453 44313238 31100b03 9e003500
+		 * CSD: 00260032 1f5983c0 ecb64fff 92404000
+		 */
+		card->cid.manfid       = UNSTUFF_BITS(resp, 120, 8);
+		card->cid.oemid	  = UNSTUFF_BITS(resp, 104, 16);
+		card->cid.prod_name[0] = UNSTUFF_BITS(resp, 96, 8);
+		card->cid.prod_name[1] = UNSTUFF_BITS(resp, 88, 8);
+		card->cid.prod_name[2] = UNSTUFF_BITS(resp, 80, 8);
+		card->cid.prod_name[3] = UNSTUFF_BITS(resp, 72, 8);
+		card->cid.prod_name[4] = UNSTUFF_BITS(resp, 64, 8);
+		card->cid.hwrev        = UNSTUFF_BITS(resp, 60, 4);
+		card->cid.fwrev        = UNSTUFF_BITS(resp, 56, 4);
+		card->cid.serial       = UNSTUFF_BITS(resp, 24, 32);
+		card->cid.year         = UNSTUFF_BITS(resp, 12, 8);
+		card->cid.month        = UNSTUFF_BITS(resp, 8, 4);
+	
+		card->cid.year += 2000; /* SD cards year offset */
+		break;
+	
 	case 1: /* MMC v1.4 */
 		card->cid.manfid	= UNSTUFF_BITS(resp, 104, 24);
 		card->cid.prod_name[0]	= UNSTUFF_BITS(resp, 96, 8);
@@ -369,7 +430,7 @@
 /*
  * Given a 128-bit response, decode to our card CSD structure.
  */
-static void mmc_decode_csd(struct mmc_card *card)
+static int  mmc_decode_csd(struct mmc_card *card)
 {
 	struct mmc_csd *csd = &card->csd;
 	unsigned int e, m, csd_struct;
@@ -380,11 +441,11 @@
 	 * v2 has extra information in bits 15, 11 and 10.
 	 */
 	csd_struct = UNSTUFF_BITS(resp, 126, 2);
-	if (csd_struct != 1 && csd_struct != 2) {
+	if (csd_struct !=0 && csd_struct != 1 && csd_struct != 2) {
 		printk("%s: unrecognised CSD structure version %d\n",
 			card->host->host_name, csd_struct);
 		mmc_card_set_bad(card);
-		return;
+		return 1;
 	}
 
 	csd->mmca_vsn	 = UNSTUFF_BITS(resp, 122, 4);
@@ -403,6 +464,8 @@
 	csd->capacity	  = (1 + m) << (e + 2);
 
 	csd->read_blkbits = UNSTUFF_BITS(resp, 80, 4);
+	
+	return 0;
 }
 
 /*
@@ -423,10 +486,9 @@
  * Allocate a new MMC card, and assign a unique RCA.
  */
 static struct mmc_card *
-mmc_alloc_card(struct mmc_host *host, u32 *raw_cid, unsigned int *frca)
+mmc_alloc_card(struct mmc_host *host, u32 *raw_cid)
 {
-	struct mmc_card *card, *c;
-	unsigned int rca = *frca;
+	struct mmc_card *card;
 
 	card = kmalloc(sizeof(struct mmc_card), GFP_KERNEL);
 	if (!card)
@@ -435,18 +497,24 @@
 	mmc_init_card(card, host);
 	memcpy(card->raw_cid, raw_cid, sizeof(card->raw_cid));
 
+	return card;
+}
+
+/*
+ * allocate a unique RCA
+ */
+static unsigned int mmc_alloc_rca(struct mmc_host *host, unsigned short *frca) {
+	unsigned short rca = *frca;
+	struct mmc_card *card;
  again:
-	list_for_each_entry(c, &host->cards, node)
-		if (c->rca == rca) {
+	list_for_each_entry(card, &host->cards, node) {
+		if (card->rca == rca) {
 			rca++;
 			goto again;
 		}
-
-	card->rca = rca;
-
-	*frca = rca;
-
-	return card;
+	}
+	printk("Allocated rca: %04x\n", rca);
+	return rca;
 }
 
 /*
@@ -495,31 +563,50 @@
 	host->ops->set_ios(host, &host->ios);
 }
 
-static int mmc_send_op_cond(struct mmc_host *host, u32 ocr, u32 *rocr)
+static int mmc_send_op_cond(struct mmc_host *host, u32 ocr, u32 *rocr, int init_opcode, int *is_sd)
 {
 	struct mmc_command cmd;
 	int i, err = 0;
-
-	cmd.opcode = MMC_SEND_OP_COND;
-	cmd.arg = ocr;
-	cmd.flags = MMC_RSP_R3;
+	int init_flags = 0;
 
 	for (i = 100; i; i--) {
+		if(init_opcode == SD_APP_OP_COND) {
+			cmd.opcode = MMC_APP_CMD;
+			cmd.arg = 0;
+			cmd.flags = MMC_RSP_R1;
+			err = mmc_wait_for_cmd(host, &cmd, 0);
+
+			if(err != MMC_ERR_NONE)
+				init_opcode = MMC_SEND_OP_COND; // fallback to MMC
+			else
+				init_flags = MMC_FLAG_ACMD;
+		}
+
+		cmd.opcode = init_opcode;
+		cmd.arg = ocr;
+		cmd.flags = MMC_RSP_R3 | init_flags;
 		err = mmc_wait_for_cmd(host, &cmd, 0);
+
 		if (err != MMC_ERR_NONE)
 			break;
 
-		if (cmd.resp[0] & MMC_CARD_BUSY || ocr == 0)
+		if (cmd.resp[0] & MMC_CARD_BUSY || ocr == 0) {
+			if(rocr)
+				*rocr = cmd.resp[0];
+			if(is_sd) {
+				if(init_opcode == SD_APP_OP_COND)
+					*is_sd = 1;
+				else
+					*is_sd = 0;
+			}
 			break;
+		}
 
 		err = MMC_ERR_TIMEOUT;
 
 		mmc_delay(10);
 	}
 
-	if (rocr)
-		*rocr = cmd.resp[0];
-
 	return err;
 }
 
@@ -531,10 +618,11 @@
  * Create a mmc_card entry for each discovered card, assigning
  * it an RCA, and save the raw CID for decoding later.
  */
-static void mmc_discover_cards(struct mmc_host *host)
+static void mmc_discover_cards(struct mmc_host *host, int is_sd)
 {
 	struct mmc_card *card;
-	unsigned int first_rca = 1, err;
+	unsigned int err;
+	unsigned short frca = 1;
 
 	while (1) {
 		struct mmc_command cmd;
@@ -556,7 +644,7 @@
 
 		card = mmc_find_card(host, cmd.resp);
 		if (!card) {
-			card = mmc_alloc_card(host, cmd.resp, &first_rca);
+			card = mmc_alloc_card(host, cmd.resp);
 			if (IS_ERR(card)) {
 				err = PTR_ERR(card);
 				break;
@@ -564,15 +652,38 @@
 			list_add(&card->node, &host->cards);
 		}
 
+		/* SD cards allocate their own RCA. MMC cards have one allocated
+		 * for them by us.
+		 */
 		card->state &= ~MMC_STATE_DEAD;
+		if(is_sd){
+			cmd.opcode = MMC_SEND_RELATIVE_ADDR;
+			cmd.arg = 0; // ignored
+			cmd.flags = MMC_RSP_R6;
+			card->state |= MMC_STATE_IS_SD;
+		}
+		else{
+			card->rca = mmc_alloc_rca(host, &frca);
+			cmd.opcode = MMC_SET_RELATIVE_ADDR;
+			cmd.arg = card->rca << 16;
+			cmd.flags = MMC_RSP_R1;
+		}
 
-		cmd.opcode = MMC_SET_RELATIVE_ADDR;
-		cmd.arg = card->rca << 16;
-		cmd.flags = MMC_RSP_R1;
-
+		/* Sandisk say: should ignore ILLEGAL_COMMAND errors
+		 * as CMD{0,1,2} dont clear status and an SD probe can
+		 * upset MMC cards.
+		 */
 		err = mmc_wait_for_cmd(host, &cmd, CMD_RETRIES);
+
 		if (err != MMC_ERR_NONE)
-			mmc_card_set_dead(card);
+			if(err != MMC_ERR_INVALID)
+				mmc_card_set_dead(card);
+
+		if(is_sd){
+			card->rca = cmd.resp[0] >> 16;
+			printk("Card wants rca: %08x\n", cmd.resp[0]);
+			frca = card->rca;
+		}
 	}
 }
 
@@ -599,7 +710,10 @@
 
 		memcpy(card->raw_csd, cmd.resp, sizeof(card->raw_csd));
 
-		mmc_decode_csd(card);
+		if (mmc_decode_csd(card)) {
+			card->state |= MMC_STATE_DEAD;
+			continue;
+		}
 		mmc_decode_cid(card);
 	}
 }
@@ -652,28 +766,11 @@
 
 static void mmc_setup(struct mmc_host *host)
 {
-	if (host->ios.power_mode != MMC_POWER_ON) {
-		int err;
-		u32 ocr;
-
-		mmc_power_up(host);
-		mmc_idle_cards(host);
-
-		err = mmc_send_op_cond(host, 0, &ocr);
-		if (err != MMC_ERR_NONE)
-			return;
-
-		host->ocr = mmc_select_voltage(host, ocr);
-
-		/*
-		 * Since we're changing the OCR value, we seem to
-		 * need to tell some cards to go back to the idle
-		 * state.  We wait 1ms to give cards time to
-		 * respond.
-		 */
-		if (host->ocr)
-			mmc_idle_cards(host);
-	} else {
+	int err, is_sd;
+	u32 ocr;
+	struct mmc_command cmd;
+	/* Enter idle mode from whatever state we are in */
+	if (host->ios.power_mode == MMC_POWER_ON) {
 		host->ios.bus_mode = MMC_BUSMODE_OPENDRAIN;
 		host->ios.clock = host->f_min;
 		host->ops->set_ios(host, &host->ios);
@@ -692,8 +789,15 @@
 		 * they drop off the bus.
 		 */
 	}
+	else {
+		mmc_power_up(host);
+		err =  mmc_send_op_cond(host, 0, &ocr, SD_APP_OP_COND, &is_sd);
+		if(err != MMC_ERR_NONE)
+			return;
+		host->ocr = mmc_select_voltage(host, ocr);
+	}
 
-	if (host->ocr == 0)
+	if (!host->ocr)
 		return;
 
 	/*
@@ -701,9 +805,22 @@
 	 * all get the idea that they should be ready for CMD2.
 	 * (My SanDisk card seems to need this.)
 	 */
-	mmc_send_op_cond(host, host->ocr, NULL);
 
-	mmc_discover_cards(host);
+	/* Try SD cards first */
+	if(is_sd){
+		err = mmc_send_op_cond(host, host->ocr, NULL, SD_APP_OP_COND, NULL);
+		if(err == MMC_ERR_NONE)
+			mmc_discover_cards(host, 1);
+	}
+	
+	err = mmc_send_op_cond(host, host->ocr, NULL, MMC_SEND_OP_COND, NULL);
+	if(err == MMC_ERR_NONE)
+		mmc_discover_cards(host, 0);
+
+	cmd.opcode = MMC_SELECT_CARD;
+        cmd.arg = 0;
+        cmd.flags = MMC_RSP_NONE;
+        mmc_wait_for_cmd(host, &cmd, 0);
 
 	/*
 	 * Ok, now switch to push-pull mode.
diff -Nur linux-2.6.9-intc1/drivers/mmc/mmci.c linux-2.6.9-intc1-mih1/drivers/mmc/mmci.c
--- linux-2.6.9-intc1/drivers/mmc/mmci.c	2004-10-18 17:54:39.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/mmc/mmci.c	2005-05-01 01:52:54.000000000 -0400
@@ -14,14 +14,15 @@
 #include <linux/ioport.h>
 #include <linux/device.h>
 #include <linux/interrupt.h>
-#include <linux/blkdev.h>
 #include <linux/delay.h>
 #include <linux/err.h>
+#include <linux/highmem.h>
 #include <linux/mmc/host.h>
 #include <linux/mmc/protocol.h>
 
 #include <asm/io.h>
 #include <asm/irq.h>
+#include <asm/scatterlist.h>
 #include <asm/hardware/amba.h>
 #include <asm/hardware/clock.h>
 #include <asm/mach/mmc.h>
@@ -69,7 +70,7 @@
 static void mmci_start_data(struct mmci_host *host, struct mmc_data *data)
 {
 	unsigned int datactrl, timeout, irqmask;
-	void *base;
+	void __iomem *base;
 
 	DBG(host, "blksz %04x blks %04x flags %08x\n",
 	    1 << data->blksz_bits, data->blocks, data->flags);
@@ -108,7 +109,7 @@
 static void
 mmci_start_command(struct mmci_host *host, struct mmc_command *cmd, u32 c)
 {
-	void *base = host->base;
+	void __iomem *base = host->base;
 
 	DBG(host, "op %02x arg %08x flags %08x\n",
 	    cmd->opcode, cmd->arg, cmd->flags);
@@ -169,7 +170,7 @@
 mmci_cmd_irq(struct mmci_host *host, struct mmc_command *cmd,
 	     unsigned int status)
 {
-	void *base = host->base;
+	void __iomem *base = host->base;
 
 	host->cmd = NULL;
 
@@ -193,7 +194,7 @@
 
 static int mmci_pio_read(struct mmci_host *host, char *buffer, unsigned int remain)
 {
-	void *base = host->base;
+	void __iomem *base = host->base;
 	char *ptr = buffer;
 	u32 status;
 
@@ -222,7 +223,7 @@
 
 static int mmci_pio_write(struct mmci_host *host, char *buffer, unsigned int remain, u32 status)
 {
-	void *base = host->base;
+	void __iomem *base = host->base;
 	char *ptr = buffer;
 
 	do {
@@ -251,7 +252,7 @@
 static irqreturn_t mmci_pio_irq(int irq, void *dev_id, struct pt_regs *regs)
 {
 	struct mmci_host *host = dev_id;
-	void *base = host->base;
+	void __iomem *base = host->base;
 	u32 status;
 
 	status = readl(base + MMCISTATUS);
@@ -501,7 +502,7 @@
 	 * We can do SGIO
 	 */
 	mmc->max_hw_segs = 16;
-	mmc->max_phys_segs = 16;
+	mmc->max_phys_segs = NR_SG;
 
 	/*
 	 * Since we only have a 16-bit data length register, we must
diff -Nur linux-2.6.9-intc1/drivers/mmc/mmci.h linux-2.6.9-intc1-mih1/drivers/mmc/mmci.h
--- linux-2.6.9-intc1/drivers/mmc/mmci.h	2004-10-18 17:55:36.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/mmc/mmci.h	2005-02-22 18:30:18.000000000 -0500
@@ -120,7 +120,7 @@
 struct clk;
 
 struct mmci_host {
-	void			*base;
+	void __iomem		*base;
 	struct mmc_request	*mrq;
 	struct mmc_command	*cmd;
 	struct mmc_data		*data;
@@ -139,7 +139,6 @@
 	struct timer_list	timer;
 	unsigned int		oldstat;
 
-	struct scatterlist	sg[NR_SG];
 	unsigned int		sg_len;
 
 	/* pio stuff */
@@ -156,8 +155,8 @@
 	/*
 	 * Ideally, we want the higher levels to pass us a scatter list.
 	 */
-	host->sg_len = blk_rq_map_sg(req->q, req, sg);
-	host->sg_ptr = sg;
+	host->sg_len = data->sg_len;
+	host->sg_ptr = data->sg;
 	host->sg_off = 0;
 }
 
